<?php
  function errorHeader(){
    header('HTTP/1.1 503 Service Temporarily Unavailable');
    header('Status: 503 Service Temporarily Unavailable');
    header('Retry-After: 3600');
    header("Content-type: text/html; charset=utf-8");
  }
  
  function errorBox($title,$message){
    echo "<!-- ErrorEncountered --><div style=\"width:450px\" class=\"msgbox\"><div class=\"head\">".$title."</div><div>".$message."</div></div><!-- ErrorEncounteredEnd -->";
  }
  
// Destinations
// define("ADMIN_EMAIL", "fish@archa.cz");
  define("LOG_FILE", LOG_DIR."/error.log");
 
// Destination types
  define("DEST_EMAIL", "1");
  define("DEST_LOGFILE", "3");

  $ErrorHandled=FALSE;
  
  function getSqlProcess() {
    $SqlProcess = "";
    if (isset($GLOBALS["DB_ERROR_DSN"])) {    
      $dbhErr = MDB2::connect($GLOBALS["DB_ERROR_DSN"],$GLOBALS["DB_OPTIONS"]);
      if (!PEAR::isError($dbhErr)) {
        $dbhErr->loadModule('Extended');
        $dbhErr->setFetchMode(MDB2_FETCHMODE_ASSOC);
        $query = "SHOW FULL PROCESSLIST";
        if (!PEAR::isError($process=$dbhErr->getAll($query))) {
          $SqlProcess.= "\nSQL PROCESS=".print_r($process, TRUE);
        }
        $dbhErr->disconnect();
      }
    }
    return($SqlProcess);
  }
 
  /**
    * my_error_handler($errno, $errstr, $errfile, $errline)
    *
    * Author(s): thanosb, ddonahue
    * Date: May 11, 2008
    * 
    * custom error handler
    *
    * Parameters:
    *  $errno:   Error level
    *  $errstr:  Error message
    *  $errfile: File in which the error was raised
    *  $errline: Line at which the error occurred
    */
   
  function my_error_handler($errno, $errstr, $errfile, $errline)
  {
    $ErrInfo=date("Y-m-d H:i:s.u")." ".$_SERVER["REQUEST_URI"]."\n";
    
    $ErrFooter="\n\$_SERVER=".print_r($_SERVER,TRUE)."\n\$_REQUEST=".print_r($_REQUEST,TRUE)."\n-----------------------------------------------------------------------------------------------------------\n\n";
    switch ($errno) {
      case E_USER_ERROR:
        $SqlProcess = getSqlProcess(); 
        if(defined("ADMIN_EMAIL")){
          // Send an e-mail to the administrator       
          error_log($ErrInfo."Error: $errstr \n Fatal error on line $errline in file $errfile \n".$SqlProcess.$ErrFooter, DEST_EMAIL, ADMIN_EMAIL);
        }
   
        // Write the error to our log file
        error_log($ErrInfo."Error: $errstr \n Fatal error on line $errline in file $errfile \n".$SqlProcess.$ErrFooter, DEST_LOGFILE, LOG_FILE);
        if(!$GLOBALS["ErrorHandled"]){
          $GLOBALS["ErrorHandled"]=TRUE;
          errorBox("Neočekávaná chyba serveru","Vážení zákazníci, na serveru došlo k chybě, tato informace byla odeslána administrátorovi, na obnovení chodu stránek se pracuje. Za způsobené potíže se omlouváme.<br />".date("H:i:s d.m.Y"));
        }
        break;
   
      case E_USER_WARNING:
        $SqlProcess = getSqlProcess(); 
        // Write the error to our log file
        error_log($ErrInfo."Warning: $errstr \n in $errfile on line $errline \n".$SqlProcess.$ErrFooter, DEST_LOGFILE, LOG_FILE);
        if(!$GLOBALS["ErrorHandled"]){
          $GLOBALS["ErrorHandled"]=TRUE;
          errorBox("Neočekávaná chyba serveru","Vážení zákazníci, na serveru došlo k chybě, tato informace byla odeslána administrátorovi, na obnovení chodu stránek se pracuje. Za způsobené potíže se omlouváme.<br />".date("H:i:s d.m.Y"));
        }
        break;
   
      case E_USER_NOTICE:
        $SqlProcess = getSqlProcess(); 
        // Write the error to our log file
        error_log($ErrInfo."Notice: $errstr \n in $errfile on line $errline \n".$SqlProcess.$ErrFooter, DEST_LOGFILE, LOG_FILE);
        break;
   
      // default:
        // // Write the error to our log file
        // error_log("Unknown error [#$errno]: $errstr \n in $errfile on line $errline \n", DEST_LOGFILE, LOG_FILE);
        // break;
    }
   
    // Don't execute PHP's internal error handler
    return TRUE;
  }
 
 
// Use set_error_handler() to tell PHP to use our method
// $old_error_handler = set_error_handler("my_error_handler");  
?>
