<?php

  // {{{ ValidateMail
  /**
   * Zkontroluje pravost zadaneho e-mailu
   *
   * @param string mail
   * @return boolean
   */
  function ValidateMail($mail){
    $mail_tmp=explode("@",$mail);
    if(!preg_match("/^\./",$mail) && !preg_match("/\.\@/",$mail) && preg_match("/^[a-z0-9\!\#\$\%\*\/\?\|\^\{\}\`\~\&\'\+\-\=\_\.]+\@([a-z0-9\_\-]+\.)+[a-z]{2,4}$/i",$mail) && ((getmxrr($mail_tmp[1],$mail_tmp2)===TRUE) || (gethostbyname($mail_tmp[1])!=$mail_tmp[1]))){
      return(TRUE);
    } else {
      return(FALSE);
    }
  }
  // }}} ValidateForm

  // {{{ ValidateForm
  /**
   * Zkontroluje spravnost vyplneni formulare podle predlohy
   *
   * @param array &$from_info struktura dat formulare
   * @param array &$from_data data formulare
   * @return boolean
   */
  function ValidateForm(&$form_info,&$form_data){
    $retval=TRUE;
    foreach($form_info as $vname=>&$info){
      if($info["type"]=="check" && !isset($form_data[$vname])){
        $form_data[$vname]="";
      }
      if(isset($form_data[$vname])){
        if (is_scalar($form_data[$vname])) {
          $form_data[$vname]=trim($form_data[$vname]);
        }
        if(get_magic_quotes_gpc()){
          $form_data[$vname]=stripslashes($form_data[$vname]);
        }
      }
      if(isset($info["req"]) && $info["req"]==1 && (!isset($form_data[$vname]) || $form_data[$vname]=="")){
        $info["status"]=_("Hodnota je povinná");
        $retval=FALSE;
      } else {
        if(isset($info["match"])){
          if(preg_match("/^#(.+)$/",$info["match"],$tmp_match)){
            if(function_exists($tmp_match[1])){
              if(!isset($form_data[$vname]) || !$tmp_match[1]($form_data[$vname])){
                $info["status"]=_("Špatná hodnota");
                $retval=FALSE;
              }
            } else {
              $info["status"]=_("Hodnota neověřena");
              $retval=FALSE;
            }
          } else if(preg_match("/^(\/.+\/)$/",$info["match"],$tmp_match)){
            if(!isset($form_data[$vname]) || !preg_match($tmp_match[1],$form_data[$vname])){
              $info["status"]=_("Špatná hodnota");
              $retval=FALSE;
            }
          } else if(preg_match("/^=(.+)$/",$info["match"],$tmp_match)){
            if(!isset($form_data[$vname]) || $form_data[$vname]!=$form_data[$tmp_match[1]]){
              $info["status"]=_("Hodnota neodpovídá poli")." \"".$form_info[$tmp_match[1]]["label"]."\"";
              $retval=FALSE;
            }
          } else {
            if(!isset($form_data[$vname]) || $form_data[$vname]!=$info["match"]){
              $info["status"]=_("Špatná hodnota");
              $retval=FALSE;
            }
          }
        }
      }
      if ($info["type"]=="datum") {
        //napred zkusime, jestli to tam nezadal v jinem formatu
        if (preg_match('/^(\d{1,2})\.\s*(\d{1,2})\.\s*(\d{4})$/',trim($form_data[$vname]),$res)) {
          $form_data[$vname] = $res[3].'-'.substr('00'.$res[2],-2).'-'.substr('00'.$res[1],-2);
        }
        if (!empty($form_data[$vname])) {
          if (!preg_match('/^(\d{4})-\s*(\d{1,2})-\s*(\d{1,2})$/',trim($form_data[$vname]), $res)) {
            $info["status"]=_("Špatná hodnota");
            $retval=FALSE;
          } else {
            if ($res[1]<1900 || $res[1]>2100 || !checkdate($res[2], $res[3], $res[1])) {
              $info["status"]=_("Neplatné datum");
              $retval=FALSE;
            }
          }
        }
      }
    }
    //pre_print($form_info);
    return($retval);
  }
  // }}} ValidateForm

?>
